﻿Imports SciLors_GrooveDownloader.MainWindow

Public Module Skin
    Public CurrentSkin As UIElement

    Public tabMain As TabControl

    'Basic
    Public mniCheckForUpdates As MenuItem
    Public mniAvailableSoftware As MenuItem
    Public mniSciLorsWebsite As MenuItem
    Public mniExit As MenuItem

    Public mniReconnect As MenuItem
    Public mniClearDownloadList As MenuItem

    Public mniBatchSearchAndAdd As MenuItem
    Public mniLoadPlaylists As MenuItem

    Public mniDonate As MenuItem

    Public txtSearch As TextBox
    Public btnSearch As Button
    Public btnPopularSongs As Button

    Public btnSelectAll As Button
    Public btnDeselectAll As Button
    Public btnInvertSelection As Button
    Public btnAddToDownloadList As Button
    Public dagSearch As DataGrid

    Public pgbDownloadState As ProgressBar
    Public btnDownload As Button
    Public dagDownload As DataGrid

    Public txtDebug As TextBox

    'ExtFunctions
    Public txtBatchSearch As TextBox
    Public btnBatchSearch As Button
    Public btnImportBatch As Button

    Public grpPlaylists As GroupBox
    Public txtLoginName As TextBox
    Public txtLoginPass As PasswordBox
    Public btnLoginFetchPlaylists As Button
    Public cmbFetchPlaylists As ComboBox
    Public btnFetchPlaylists As Button

    'Settings
    Public tabConfigList As TabControl

    Public txtBaseDir As TextBox
    Public btnBaseDir As Button

    Public cmbPattern As ComboBox
    Public lblPatternPreview As Label
    Public lblPatternInfo As Label

    Public rbtExistingSkip As RadioButton
    Public rbtExistingOverwrite As RadioButton
    Public rbtExistingAutoRename As RadioButton

    Public chkUncheckSearchResults As CheckBox
    Public chkAutoCheckUpdates As CheckBox

    Public btnSave As Button

    Public Sub SetControlVariables()
        Try
            tabMain = getElementByName(Of TabControl)("tabMain")

            SetBasicView()
            SetExtFunctionView()
            SetSettingsView()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub

    Private Sub SetBasicView()
        mniCheckForUpdates = getElementByName(Of MenuItem)("mniCheckForUpdates")
        mniAvailableSoftware = getElementByName(Of MenuItem)("mniAvailableSoftware")
        mniSciLorsWebsite = getElementByName(Of MenuItem)("mniSciLorsWebsite")
        mniExit = getElementByName(Of MenuItem)("mniExit")

        mniReconnect = getElementByName(Of MenuItem)("mniReconnect")
        mniClearDownloadList = getElementByName(Of MenuItem)("mniClearDownloadList")
        mniBatchSearchAndAdd = getElementByName(Of MenuItem)("mniBatchSearchAndAdd")
        mniLoadPlaylists = getElementByName(Of MenuItem)("mniLoadPlaylists")

        mniDonate = getElementByName(Of MenuItem)("mniDonate")


        txtSearch = getElementByName(Of TextBox)("txtSearch")
        btnSearch = getElementByName(Of Button)("btnSearch")
        btnPopularSongs = getElementByName(Of Button)("btnPopularSongs")

        btnSelectAll = getElementByName(Of Button)("btnSelectAll")
        btnDeselectAll = getElementByName(Of Button)("btnDeselectAll")
        btnInvertSelection = getElementByName(Of Button)("btnInvertSelection")
        btnAddToDownloadList = getElementByName(Of Button)("btnAddToDownloadList")
        dagSearch = getElementByName(Of DataGrid)("dagSearch")

        pgbDownloadState = getElementByName(Of ProgressBar)("pgbDownloadState")
        btnDownload = getElementByName(Of Button)("btnDownload")
        dagDownload = getElementByName(Of DataGrid)("dagDownload")

        txtDebug = getElementByName(Of TextBox)("txtDebug")
    End Sub

    Private Sub SetExtFunctionView()
        txtBatchSearch = getElementByName(Of TextBox)("txtBatchSearch")
        btnBatchSearch = getElementByName(Of Button)("btnBatchSearch")
        btnImportBatch = getElementByName(Of Button)("btnImportBatch")

        grpPlaylists = getElementByName(Of GroupBox)("grpPlaylists")
        txtLoginName = getElementByName(Of TextBox)("txtLoginName")
        txtLoginPass = getElementByName(Of PasswordBox)("txtLoginPass")
        btnLoginFetchPlaylists = getElementByName(Of Button)("btnLoginFetchPlaylists")
        cmbFetchPlaylists = getElementByName(Of ComboBox)("cmbFetchPlaylists")
        btnFetchPlaylists = getElementByName(Of Button)("btnFetchPlaylists")
    End Sub

    Private Sub SetSettingsView()
        tabConfigList = getElementByName(Of TabControl)("tabConfigList")

        txtBaseDir = getElementByName(Of TextBox)("txtBaseDir")
        btnBaseDir = getElementByName(Of Button)("btnBaseDir")

        cmbPattern = getElementByName(Of ComboBox)("cmbPattern")
        lblPatternPreview = getElementByName(Of Label)("lblPatternPreview")
        lblPatternInfo = getElementByName(Of Label)("lblPatternInfo")

        chkUncheckSearchResults = getElementByName(Of CheckBox)("chkUncheckSearchResults")
        chkAutoCheckUpdates = getElementByName(Of CheckBox)("chkAutoCheckUpdates")

        rbtExistingSkip = getElementByName(Of RadioButton)("rbtExistingSkip")
        rbtExistingOverwrite = getElementByName(Of RadioButton)("rbtExistingOverwrite")
        rbtExistingAutoRename = getElementByName(Of RadioButton)("rbtExistingAutoRename")

        btnSave = getElementByName(Of Button)("btnSave")
    End Sub

    Public Function getElementByName(Of T As DependencyObject)(ByVal name As String) As T
        Return TryCast(LogicalTreeHelper.FindLogicalNode(DirectCast(CurrentSkin, DependencyObject), name), T)
    End Function
End Module